#include <gtk/gtk.h>

#include "pixmaps/new.xpm"
#include "pixmaps/open.xpm"
#include "pixmaps/print.xpm"
#include "pixmaps/cut.xpm"
#include "pixmaps/copy.xpm"
#include "pixmaps/paste.xpm"
#include "pixmaps/search.xpm"
#include "pixmaps/add.xpm"
#include "pixmaps/remove.xpm"
#include "pixmaps/save.xpm"
#include "pixmaps/saveadd.xpm"
#include "pixmaps/cancel.xpm"
#include "pixmaps/caxun.xpm"
#include "pixmaps/zu.xpm"
#include "pixmaps/rename.xpm"
#include "pixmaps/suxin.xpm"
#include "pixmaps/bigico.xpm"
#include "pixmaps/smallico.xpm"
#include "pixmaps/list.xpm"
#include "pixmaps/xian.xpm"
#include "pixmaps/fenye.xpm"
#include "pixmaps/mima.xpm"
#include "pixmaps/laji.xpm"
#include "pixmaps/wannanli.xpm"
#include "pixmaps/telepho.xpm"
#include "pixmaps/question.xpm"
#include "pixmaps/up.xpm"
#include "pixmaps/down.xpm"


GtkWidget *new_button, *open_button, *print_button, *cut_button, *copy_button,
	*paste_button, *search_button, *add_button, *remove_button,
	*save_button, *saveadd_button, *cancel_button, *caxun_button,
	*zu_button, *rename_button, *suxin_button, *bigico_button,
	*smallico_button, *list_button, *xian_button, *fenye_button,
	*mima_button, *laji_button, *wannanli_button, *telepho_button,
	*question_button, *up_button, *down_button;

void kk (GtkWidget * widget, gpointer data);
GtkWidget *CreateWidgetFromXpm (GtkWidget * parent, gchar ** xpm_data);
void toolbar_save (GtkWidget * widget, gpointer data);
void toolbar_cancel (GtkWidget * widget, gpointer data);
void toolbar_remove (GtkWidget * widget, gpointer data);
void toolbar_add (GtkWidget * widget, gpointer data);
void toolbar_saveadd (GtkWidget * widget, gpointer data);
void toolbar_zu (GtkWidget * widget, gpointer data);
void toolbar_open (GtkWidget * widget, gpointer data);
void toolbar_rename (GtkWidget * widget, gpointer data);
void toolbar_new (GtkWidget * widget, gpointer data);
void toolbar_copy (GtkWidget * widget, gpointer data);
void toolbar_paste (GtkWidget * widget, gpointer data);
void show_about_window ();

void
createtoolbar (GtkWidget * parent, GtkWidget * main_vbox)
{
	GtkWidget *toolbar;

	/* --- Create the toolbar and add it to the window --- */
	toolbar =
		gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL,
				 GTK_TOOLBAR_ICONS);
	gtk_box_pack_start (GTK_BOX (main_vbox), toolbar, FALSE, FALSE, 2);
	gtk_widget_show (toolbar);

	gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

	new_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
					      NULL, "½ļ", NULL,
					      CreateWidgetFromXpm (parent,
								   (gchar **)
								   new_xpm),
					      (GtkSignalFunc) toolbar_new,
					      NULL);

	open_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
					       NULL, "ļ", NULL,
					       CreateWidgetFromXpm (parent,
								    (gchar **)
								    open_xpm),
					       (GtkSignalFunc) toolbar_open,
					       NULL);

	print_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
						NULL, "ӡ", NULL,
						CreateWidgetFromXpm (parent,
								     (gchar
								      **)
								     print_xpm),
						(GtkSignalFunc) kk, "config");
	gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

	cut_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
					      NULL, "", NULL,
					      CreateWidgetFromXpm (parent,
								   (gchar **)
								   cut_xpm),
					      (GtkSignalFunc) kk, "exit");

	copy_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
					       NULL, "", NULL,
					       CreateWidgetFromXpm (parent,
								    (gchar **)
								    copy_xpm),
					       (GtkSignalFunc) toolbar_copy,
					       NULL);

	paste_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
						NULL, "ճ", NULL,
						CreateWidgetFromXpm (parent,
								     (gchar
								      **)
								     paste_xpm),
						(GtkSignalFunc) toolbar_paste,
						NULL);

	search_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
						 NULL, "", NULL,
						 CreateWidgetFromXpm (parent,
								      (gchar
								       **)
								      search_xpm),
						 (GtkSignalFunc) kk,
						 "nextfile");

	gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

	add_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
					      NULL, "¼¼", NULL,
					      CreateWidgetFromXpm (parent,
								   (gchar **)
								   add_xpm),
					      (GtkSignalFunc) toolbar_add,
					      NULL);

	remove_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
						 NULL, "ɾ", NULL,
						 CreateWidgetFromXpm (parent,
								      (gchar
								       **)
								      remove_xpm),
						 (GtkSignalFunc)
						 toolbar_remove, NULL);
	save_button =
		gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), NULL, "",
					 NULL, CreateWidgetFromXpm (parent,
								    (gchar **)
								    save_xpm),
					 (GtkSignalFunc) toolbar_save, NULL);
	saveadd_button =
		gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), NULL,
					 "沢", NULL,
					 CreateWidgetFromXpm (parent,
							      (gchar **)
							      saveadd_xpm),
					 (GtkSignalFunc) toolbar_saveadd,
					 NULL);
	cancel_button =
		gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), NULL, "ȡ",
					 NULL, CreateWidgetFromXpm (parent,
								    (gchar **)
								    cancel_xpm),
					 (GtkSignalFunc) toolbar_cancel,
					 NULL);
	gtk_widget_set_sensitive (save_button, 0);
	gtk_widget_set_sensitive (saveadd_button, 0);
	gtk_widget_set_sensitive (cancel_button, 0);
	caxun_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
						NULL, "ѯ", NULL,
						CreateWidgetFromXpm (parent,
								     (gchar
								      **)
								     caxun_xpm),
						(GtkSignalFunc) kk,
						"addlink");
	gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));
	zu_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
					     NULL, "", NULL,
					     CreateWidgetFromXpm (parent,
								  (gchar **)
								  zu_xpm),
					     (GtkSignalFunc) toolbar_zu,
					     NULL);
	rename_button =
		gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), NULL,
					 "", NULL,
					 CreateWidgetFromXpm (parent,
							      (gchar **)
							      rename_xpm),
					 (GtkSignalFunc) toolbar_rename,
					 NULL);
	gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));
	suxin_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
						NULL, "", NULL,
						CreateWidgetFromXpm (parent,
								     (gchar
								      **)
								     suxin_xpm),
						(GtkSignalFunc) kk,
						"addlink");
	gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

	bigico_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
						    GTK_TOOLBAR_CHILD_RADIOBUTTON,
						    NULL,
						    NULL, "ͼ", NULL,
						    CreateWidgetFromXpm
						    (parent,
						     (gchar **) bigico_xpm),
						    (GtkSignalFunc) kk,
						    "addlink");

	smallico_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
						      GTK_TOOLBAR_CHILD_RADIOBUTTON,
						      bigico_button,
						      NULL, "Сͼ", NULL,
						      CreateWidgetFromXpm
						      (parent,
						       (gchar **)
						       smallico_xpm),
						      (GtkSignalFunc) kk,
						      "addlink");
	list_button =
		gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
					    GTK_TOOLBAR_CHILD_RADIOBUTTON,
					    bigico_button, NULL, "б", NULL,
					    CreateWidgetFromXpm (parent,
								 (gchar **)
								 list_xpm),
					    (GtkSignalFunc) kk, "addlink");
	xian_button =
		gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
					    GTK_TOOLBAR_CHILD_RADIOBUTTON,
					    bigico_button, NULL, "ϸ",
					    NULL, CreateWidgetFromXpm (parent,
								       (gchar
									**)
								       xian_xpm),
					    (GtkSignalFunc) kk, "addlink");
	gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (bigico_button), TRUE);

	fenye_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
						NULL, "ҳʾ", NULL,
						CreateWidgetFromXpm (parent,
								     (gchar
								      **)
								     fenye_xpm),
						(GtkSignalFunc) kk,
						"addlink");
	gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));
	mima_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
					       NULL, "", NULL,
					       CreateWidgetFromXpm (parent,
								    (gchar **)
								    mima_xpm),
					       (GtkSignalFunc) kk, "addlink");
	laji_button =
		gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), NULL,
					 "վ", NULL,
					 CreateWidgetFromXpm (parent,
							      (gchar **)
							      laji_xpm),
					 (GtkSignalFunc) kk, "addlink");
	wannanli_button =
		gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), NULL,
					 "", NULL,
					 CreateWidgetFromXpm (parent,
							      (gchar **)
							      wannanli_xpm),
					 (GtkSignalFunc) kk, "addlink");
	telepho_button =
		gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), NULL, "绰",
					 NULL, CreateWidgetFromXpm (parent,
								    (gchar **)
								    telepho_xpm),
					 (GtkSignalFunc) kk, "addlink");
	gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));
	question_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
						   NULL, "", NULL,
						   CreateWidgetFromXpm
						   (parent,
						    (gchar **) question_xpm),
						   (GtkSignalFunc)
						   show_about_window, NULL);
}

void
createtoolbar2 (GtkWidget * parent, GtkWidget * main_vbox)
{
	GtkWidget *toolbar;

	toolbar =
		gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL,
				 GTK_TOOLBAR_ICONS);

	gtk_box_pack_start (GTK_BOX (main_vbox), toolbar, FALSE, FALSE, 0);
	gtk_widget_show (toolbar);
	up_button = gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
					     NULL, "һ", NULL,
					     CreateWidgetFromXpm (parent,
								  (gchar **)
								  up_xpm),
					     (GtkSignalFunc) kk, "addlink");
	down_button =
		gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), NULL,
					 "һ", NULL,
					 CreateWidgetFromXpm (parent,
							      (gchar **)
							      down_xpm),
					 (GtkSignalFunc) kk, "addlink");
}

void
createtoolbar1 (GtkWidget * main_vbox)
{
	GtkWidget *toolbar;

	/* --- Create the toolbar and add it to the window --- */
	toolbar =
		gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL,
				 GTK_TOOLBAR_TEXT);
	gtk_box_pack_start (GTK_BOX (main_vbox), toolbar, FALSE, FALSE, 0);
	gtk_widget_show (toolbar);
	gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "a", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "b", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "c", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "d", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "e", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "f", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "g", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "h", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "j", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "k", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "l", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "m", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "n", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "o", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "p", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "q", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "r", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "s", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "t", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "w", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "x", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "y", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
	gtk_toolbar_append_item (GTK_TOOLBAR (toolbar), "z", NULL, NULL, NULL,
				 (GtkSignalFunc) kk, "a");
}
