#include "configfile.h"
#include <gtk/gtk.h>
#include <string.h>
#include <sys/stat.h>
#include <stdio.h>
#include "yqtreeitem.h"


extern gchar sFilename[256];
extern gint yesnoreturn;
extern gint clist_selectrow;
extern GdkPixmap *yqpixmaps[MAX_IMAGE_TYPES];
extern GdkBitmap *yqmasks[MAX_IMAGE_TYPES];
extern YqTreeItem *selectleaf;
extern gboolean yq_nowiszu;
extern struct _YQList yqlist;
extern GtkWidget *new_button, *open_button, *print_button, *cut_button,
	*copy_button, *paste_button, *search_button, *add_button,
	*remove_button, *save_button, *saveadd_button, *cancel_button,
	*caxun_button, *zu_button, *rename_button, *suxin_button,
	*bigico_button, *smallico_button, *list_button, *xian_button,
	*fenye_button, *mima_button, *laji_button, *wannanli_button,
	*telepho_button, *question_button, *up_button, *down_button;
extern GtkWidget *treewin;
extern GtkWidget
	* nb_1_1, *nb_1_2, *nb_1_3, *nb_1_4, *nb_1_5, *nb_1_6, *nb_1_7,
	*nb_1_8, *nb_1_9, *nb_1_10, *nb_1_11, *nb_1_12, *nb_1_13, *nb_1_14,
	*nb_1_15, *nb_1_16, *nb_1_17, *nb_1_18, *nb_2_1, *nb_2_2, *nb_2_3,
	*nb_2_4, *nb_2_5, *nb_2_6, *nb_2_7, *nb_2_8, *nb_2_9, *nb_2_10,
	*nb_2_11, *nb_2_12, *nb_2_13, *nb_3_1, *nb_3_2;
extern GtkWidget *menu_file_new, *menu_file_open, *menu_file_openold,
	*menu_file_close, *menu_file_saveas, *menu_file_exit, *menu_edit_cut,
	*menu_edit_copy, *menu_edit_paste, *menu_jilu_add, *menu_jilu_remove,
	*menu_jilu_save, *menu_jilu_saveadd, *menu_jilu_cancel, *menu_jilu_zu,
	*menu_jilu_rename, *menu_tool_option;


gboolean nb_changed, nb_isadd;
static ConfigFile *tmpcfg;

void addtotext (gchar ** a, gchar * b);
void nb_setchanged (GtkWidget * widget, gpointer data);
void leaf_setnb (gchar * ab);
void Popup (gchar * szMessage);
void Areyousure (gchar * szMessage);
void YesNo (gchar * szMessage);
void yq_tree_item_set_pixmap (YqTreeItem * treeitem, ImageType ed);
void yq_tree_item_set_text (YqTreeItem * treeitem, gchar * ab);
GtkWidget *yq_tree_item_new (gchar * ab, ImageType ed);
gchar *leaf_formattext (gchar * bd);
void toolbar_save (GtkWidget * widget, gpointer data);
void toolbar_add (GtkWidget * widget, gpointer data);
void zu_expanded (GtkWidget * widget, gpointer data);
void zu_collapsed (GtkWidget * widget, gpointer data);
void yq_cfg_remove_sections (ConfigFile * cfg, gchar * section);
void yq_cfg_rename_sections (ConfigFile * cfg, gchar * section,
			     gchar * section_name);
void yq_cfg_daiti_sections (ConfigFile * cfg, gchar * section1,
			    gchar * section2);
GtkWidget *yq_readzu (YqTreeItem * upleaf);
GtkWidget *yq_createnulltree ();
void yq_readfile (GtkWidget * widget, gpointer openfile);
void GetFilename (char *sTitle);
void InputName (gchar * szMessage, gchar * entryvalue);
void create_yqfile (gchar * filename);
void open_zu (YqTreeItem * yqitem);
void toolbar_addjilu (gchar * ab);
void toolbar_addzu ();
void toolbar_copyzu (gchar * zuname1, gchar * zuname2);





GtkWidget * yq_createnulltree ()
{
	GtkWidget *tree;

	tree = gtk_tree_new ();
	gtk_widget_show (tree);
	return tree;
}


void
yq_cfg_remove_sections (ConfigFile * cfg, gchar * section)
{
	gint i, z;
	gchar tz[260];

	yq_cfg_read_int (cfg, section, "z", &z);
	for (i = 1; i <= z; i++)
	{
		sprintf (tz, "%s_%d", section, i);
		yq_cfg_remove_sections (cfg, tz);
	}
	yq_cfg_remove_section (cfg, section);
}

void
yq_cfg_daiti_sections (ConfigFile * cfg, gchar * section1, gchar * section2)
{
	yq_cfg_remove_sections (cfg, section1);
	yq_cfg_rename_sections (cfg, section2, section1);
}

void
yq_cfg_rename_sections (ConfigFile * cfg, gchar * section,
			gchar * section_name)
{
	gint i, z;
	gchar tz1[260], tz2[260];
	yq_cfg_read_int (cfg, section, "z", &z);
	for (i = 1; i <= z; i++)
	{
		sprintf (tz1, "%s_%d", section, i);
		sprintf (tz2, "%s_%d", section_name, i);
		yq_cfg_rename_sections (cfg, tz1, tz2);
	}
	yq_cfg_rename_section (cfg, section, section_name);
}



void
nb_setchanged (GtkWidget * widget, gpointer data)
{
	if ((widget != save_button) == nb_changed)
		return;

	gtk_widget_set_sensitive (new_button, nb_changed);
	gtk_widget_set_sensitive (menu_file_new, nb_changed);
	gtk_widget_set_sensitive (open_button, nb_changed);
	gtk_widget_set_sensitive (menu_file_open, nb_changed);
	gtk_widget_set_sensitive (menu_file_openold, nb_changed);
	gtk_widget_set_sensitive (menu_file_close, nb_changed);
	gtk_widget_set_sensitive (menu_file_saveas, nb_changed);
	gtk_widget_set_sensitive (print_button, nb_changed);
	gtk_widget_set_sensitive (cut_button, nb_changed);
	gtk_widget_set_sensitive (copy_button, nb_changed);
	gtk_widget_set_sensitive (menu_edit_copy, nb_changed);
	gtk_widget_set_sensitive (paste_button, nb_changed);
	gtk_widget_set_sensitive (menu_edit_paste, nb_changed);
	gtk_widget_set_sensitive (search_button, nb_changed);
	gtk_widget_set_sensitive (add_button, nb_changed);
	gtk_widget_set_sensitive (menu_jilu_add, nb_changed);
	gtk_widget_set_sensitive (remove_button, nb_changed);
	gtk_widget_set_sensitive (menu_jilu_remove, nb_changed);
	gtk_widget_set_sensitive (zu_button, nb_changed);
	gtk_widget_set_sensitive (menu_jilu_zu, nb_changed);
	gtk_widget_set_sensitive (rename_button, nb_changed);
	gtk_widget_set_sensitive (menu_jilu_rename, nb_changed);
	gtk_widget_set_sensitive (suxin_button, nb_changed);
	gtk_widget_set_sensitive (caxun_button, nb_changed);
	gtk_widget_set_sensitive (bigico_button, nb_changed);
	gtk_widget_set_sensitive (smallico_button, nb_changed);
	gtk_widget_set_sensitive (list_button, nb_changed);
	gtk_widget_set_sensitive (xian_button, nb_changed);
	gtk_widget_set_sensitive (fenye_button, nb_changed);
	gtk_widget_set_sensitive (mima_button, nb_changed);
	gtk_widget_set_sensitive (laji_button, nb_changed);
	gtk_widget_set_sensitive (up_button, nb_changed);
	gtk_widget_set_sensitive (down_button, nb_changed);


	gtk_widget_set_sensitive (treewin, nb_changed);

	nb_changed = !nb_changed;
	gtk_widget_set_sensitive (menu_jilu_save, nb_changed);
	gtk_widget_set_sensitive (menu_jilu_saveadd, nb_changed);
	gtk_widget_set_sensitive (menu_jilu_cancel, nb_changed);
	
gtk_widget_set_sensitive (save_button, nb_changed);
	gtk_widget_set_sensitive (saveadd_button, nb_changed);
	gtk_widget_set_sensitive (cancel_button, nb_changed);
}

void
addtotext (gchar ** a, gchar * bb)
{
	gint i;
	gchar *b;
	if (*bb == '\0')
	{
		**a = '~';
		(*a)++;
		**a = '0';
		(*a)++;
	}
	else
	{
		b = bb;
		for (i = 1; i <= strlen (bb); i++)
		{
			switch (*b)
			{
			case '~':
				**a = '~';
				(*a)++;
				**a = '~';
				break;
			case '\n':
				**a = '~';
				(*a)++;
				**a = 'n';
				break;
			case ',':
				**a = '~';
				(*a)++;
				**a = 'd';
				break;
			default:
				**a = *b;
				break;
			}
			(*a)++;
			b++;
		}
	}
	**a = ',';
	(*a)++;
}

void
toolbar_save (GtkWidget * widget, gpointer data)
{
	gchar *ab, *a, bb[260], *c;

	if (*gtk_entry_get_text (GTK_ENTRY (nb_1_1)) == '\0')
	{
		Popup ("");
		return;
	}
	ab = g_malloc (10000);
	a = ab;
	c = gtk_entry_get_text (GTK_ENTRY (nb_1_1));
	if (!nb_isadd)
		yq_tree_item_set_text (selectleaf, c);
	addtotext (&a, c);
	if (!strcmp
	    (gtk_entry_get_text (GTK_ENTRY (GTK_COMBO (nb_1_2)->entry)),
	     ""))
	{
		strcpy (bb, "1");
		if (!nb_isadd)
			yq_tree_item_set_pixmap (selectleaf, BOY);
	}
	else
	{
		strcpy (bb, "0");
		if (!nb_isadd)
			yq_tree_item_set_pixmap (selectleaf, GIRL);
	}
	addtotext (&a, bb);
	if (!strcmp
	    (gtk_entry_get_text (GTK_ENTRY (GTK_COMBO (nb_1_3)->entry)),
	     ""))
		strcpy (bb, "1");
	else
		strcpy (bb, "0");
	addtotext (&a, bb);
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_5)));
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (nb_1_4)))
		strcpy (bb, "1");
	else
		strcpy (bb, "0");
	addtotext (&a, bb);
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_6)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_7)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_8)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_9)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_10)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_11)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_12)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_13)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_14)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_15)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_16)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_17)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_1_18)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_2_1)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_2_2)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_2_3)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_2_4)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_2_5)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_2_6)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_2_7)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_2_8)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_2_9)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_2_10)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_2_11)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_2_12)));
	addtotext (&a, gtk_entry_get_text (GTK_ENTRY (nb_2_13)));
	c = gtk_editable_get_chars (GTK_EDITABLE (nb_3_1), (gint) 0,
				    (gint) - 1);
	addtotext (&a, c);
	g_free (c);
	c = gtk_editable_get_chars (GTK_EDITABLE (nb_3_2), (gint) 0,
				    (gint) - 1);
	addtotext (&a, c);
	g_free (c);
	a--;
	*a = '\0';
	nb_setchanged (save_button, NULL);
	if (!nb_isadd)
	{
		strcpy (bb, selectleaf->nodename);
		a = strchr (bb, '-');
		*a = '\0';
		a++;
		yq_cfg_write_string (selectleaf->cfg, bb, a, ab);
	}
	else
		toolbar_addjilu (ab);
	g_free (ab);
}

void
toolbar_addjilu (gchar * ab)
{
	YqTreeItem *leaf;
	gchar bb[260], *a, zu[256];
	gint i, n;

	a = strchr (ab, ',');
	*a = '\0';
	strcpy (bb, ab);
	leaf_formattext (bb);
	*a = ',';
	if (*(a + 1) == '1')
		leaf = YQ_TREE_ITEM (yq_tree_item_new (bb, BOY));
	else
		leaf = YQ_TREE_ITEM (yq_tree_item_new (bb, GIRL));

	leaf->cfg = selectleaf->cfg;
	if (yq_nowiszu)
	{
		strcpy (zu, selectleaf->nodename);
		if (!GTK_TREE_ITEM (selectleaf)->subtree)
			gtk_tree_item_set_subtree (GTK_TREE_ITEM (selectleaf),
						   yq_createnulltree ());
		if (!GTK_TREE_ITEM (selectleaf)->expanded)
			gtk_tree_item_expand (GTK_TREE_ITEM (selectleaf));
		gtk_tree_append (GTK_TREE
				 (GTK_TREE_ITEM (selectleaf)->subtree),
				 GTK_WIDGET (leaf));
		leaf->attree = GTK_TREE (GTK_TREE_ITEM (selectleaf)->subtree);
	}
	else
	{
		strcpy (zu, selectleaf->nodename);
		a = strchr (zu, '-');
		*a = '\0';
		gtk_tree_append (selectleaf->attree, GTK_WIDGET (leaf));
		leaf->attree = selectleaf->attree;
	}

	yq_cfg_read_int (selectleaf->cfg, zu, "a", &i);
	i++;
	sprintf (bb, "%s-%d", zu, i);
	strcpy (leaf->nodename, bb);
	sprintf (bb, "%d", i);
	yq_cfg_write_string (leaf->cfg, zu, bb, ab);
	yq_cfg_write_int (leaf->cfg, zu, "a", i);
	nb_isadd = 0;
	yq_cfg_read_int (leaf->cfg, zu, "z", &n);
	n = i + n - 1;
	gtk_tree_select_item (GTK_TREE (YQ_TREE_ITEM (leaf)->attree), n);
}

void
toolbar_saveadd (GtkWidget * widget, gpointer data)
{
	toolbar_save (save_button, NULL);
	toolbar_add (add_button, NULL);
}


void
toolbar_cancel (GtkWidget * widget, gpointer data)
{
	gchar *ab, zu[260], *a, tj[4];

	if (yq_nowiszu)
	{
		open_zu (selectleaf);
		gtk_clist_select_row (GTK_CLIST (yqlist.list),
				      clist_selectrow, 0);
	}
	else
	{
		strcpy (zu, selectleaf->nodename);
		a = strchr (zu, '-');
		*a = '\0';
		a++;
		strcpy (tj, a);
		yq_cfg_read_string (selectleaf->cfg, zu, tj, &ab);
		leaf_setnb (ab);
		g_free (ab);
	}
	nb_setchanged (save_button, NULL);
	nb_isadd = 0;
}


void
toolbar_remove (GtkWidget * widget, gpointer data)
{
	gint i, n, j, z, torm;
	gchar *ab, ti[4], tj[4], tz[260], aa1[260], aa2[260], *bb;
	GList *children;
	YqTreeItem *treeitem, *rmitem;

	if (selectleaf->nodename[0] == '\0')
		return;
	if (!yq_nowiszu)
	{
		torm = 1;
		rmitem = selectleaf;
	}
	else
	{
		if (clist_selectrow == -1)
		{
			torm = 2;
			rmitem = selectleaf;
		}
		else
		{
			rmitem = (YqTreeItem *)
				gtk_clist_get_row_data (GTK_CLIST
							(yqlist.list),
							clist_selectrow);
			if (strchr (rmitem->nodename, '-'))
				torm = 3;
			else
				torm = 4;
		}
	}
	if ((torm == 2) && (strcmp (selectleaf->nodename, "yq") == 0))
		return;
	strcpy (tz, rmitem->nodename);
	if ((torm == 1) || (torm == 3))
	{
		bb = strchr (tz, '-');
		*bb = '\0';
		bb++;
		strcpy (ti, bb);
		j = atoi (ti);
		yq_cfg_read_int (rmitem->cfg, tz, "z", &z);
		yq_cfg_read_int (rmitem->cfg, tz, "a", &n);
		children =
			g_list_nth (gtk_container_children
				    (GTK_CONTAINER (rmitem->attree)),
				    z + j - 1);
		for (i = j; i < n; i++)
		{
			sprintf (ti, "%d", i);
			sprintf (tj, "%d", i + 1);
			yq_cfg_read_string (rmitem->cfg, tz, tj, &ab);
			yq_cfg_write_string (rmitem->cfg, tz, ti, ab);
			children = children->next;
			treeitem = YQ_TREE_ITEM (children->data);
			sprintf (aa1, "%s-%d", tz, i);
			strcpy (treeitem->nodename, aa1);
		}
		yq_cfg_write_int (rmitem->cfg, tz, "a", n - 1);
		sprintf (tj, "%d", n);
		yq_cfg_remove_key (rmitem->cfg, tz, tj);
	}
	else
	{
		bb = strrchr (tz, '_');
		yq_cfg_read_string (rmitem->cfg, tz, "n", &ab);
		sprintf (aa1, "ȷʵҪɾ \"%s\" ?", ab);
		g_free (ab);
		Areyousure (aa1);
		if (!yesnoreturn)
			return;
		*bb = '\0';
		bb++;
		strcpy (ti, bb);
		j = atoi (ti);
		yq_cfg_read_int (rmitem->cfg, tz, "z", &z);
		yq_cfg_read_int (rmitem->cfg, tz, "a", &n);
		children =
			g_list_nth (gtk_container_children
				    (GTK_CONTAINER (rmitem->attree)), j - 1);
		yq_cfg_write_int (rmitem->cfg, tz, "z", z - 1);
		yq_cfg_remove_sections (rmitem->cfg, rmitem->nodename);
		if (strcmp (tz, rmitem->nodename) != 0)
			for (i = j; i < z; i++)
			{
				sprintf (aa1, "%s_%d", tz, i);
				sprintf (aa2, "%s_%d", tz, i + 1);
				yq_cfg_rename_sections (rmitem->cfg, aa2,
							aa1);
				children = children->next;
				treeitem = YQ_TREE_ITEM (children->data);
				strcpy (treeitem->nodename, aa1);
			}
	}
	if (torm == 1)
	{
		if (z + n == 1)
			gtk_tree_select_child (YQ_TREE_ITEM
					       (GTK_TREE (rmitem->attree)->
						tree_owner)->attree,
					       GTK_TREE (rmitem->attree)->
					       tree_owner);
		else
		{
			if (j == n)
				j = j + z - 2;
			else
				j = j + z;
		}
		gtk_tree_select_item (rmitem->attree, j);
	}
	if (torm == 2)
	{
		if (z + n == 1)
			gtk_tree_select_child (YQ_TREE_ITEM
					       (GTK_TREE (rmitem->attree)->
						tree_owner)->attree,
					       GTK_TREE (rmitem->attree)->
					       tree_owner);
		else
		{
			if ((j == z) && (z != 1))
				j = j - 2;
		}
		gtk_tree_select_item (rmitem->attree, j);
	}
	gtk_tree_remove_item (rmitem->attree, GTK_WIDGET (rmitem));
	if ((torm == 3) || (torm == 4))
		open_zu (selectleaf);
	if (torm == 3)
	{
		if (j == n)
			j = j + z - 2;
		else
			j = j + z - 1;
		gtk_clist_select_row (GTK_CLIST (yqlist.list), j, 0);
	}
	if (torm == 4)
	{
		if ((j == z) && (z != 1))
			j = j - 2;
		else
			j--;
		gtk_clist_select_row (GTK_CLIST (yqlist.list), j, 0);
	}
}

void
toolbar_add (GtkWidget * widget, gpointer data)
{
	if (selectleaf->nodename[0] == '\0')
		return;
	if (yqlist.type == LIST_DETAILS)
		yq_set_list_type (LIST_NOTEBOOK);
	else
	{
		nb_changed = 1;
		gtk_entry_set_text (GTK_ENTRY (nb_1_1), "");
		gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (nb_1_2)->entry),
				    "");
		gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (nb_1_3)->entry),
				    "");
		gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (nb_1_4), 0);
		gtk_entry_set_text (GTK_ENTRY (nb_1_5), "");
		gtk_entry_set_text (GTK_ENTRY (nb_1_6), "");
		gtk_entry_set_text (GTK_ENTRY (nb_1_7), "");
		gtk_entry_set_text (GTK_ENTRY (nb_1_8), "");
		gtk_entry_set_text (GTK_ENTRY (nb_1_9), "");
		gtk_entry_set_text (GTK_ENTRY (nb_1_10), "");
		gtk_entry_set_text (GTK_ENTRY (nb_1_11), "");
		gtk_entry_set_text (GTK_ENTRY (nb_1_12), "");
		gtk_entry_set_text (GTK_ENTRY (nb_1_13), "");
		gtk_entry_set_text (GTK_ENTRY (nb_1_14), "");
		gtk_entry_set_text (GTK_ENTRY (nb_1_15), "");
		gtk_entry_set_text (GTK_ENTRY (nb_1_16), "");
		gtk_entry_set_text (GTK_ENTRY (nb_1_17), "");
		gtk_entry_set_text (GTK_ENTRY (nb_1_18), "");

		gtk_entry_set_text (GTK_ENTRY (nb_2_1), "");
		gtk_entry_set_text (GTK_ENTRY (nb_2_2), "");
		gtk_entry_set_text (GTK_ENTRY (nb_2_3), "");
		gtk_entry_set_text (GTK_ENTRY (nb_2_4), "");
		gtk_entry_set_text (GTK_ENTRY (nb_2_5), "");
		gtk_entry_set_text (GTK_ENTRY (nb_2_6), "");
		gtk_entry_set_text (GTK_ENTRY (nb_2_7), "");
		gtk_entry_set_text (GTK_ENTRY (nb_2_8), "");
		gtk_entry_set_text (GTK_ENTRY (nb_2_9), "");
		gtk_entry_set_text (GTK_ENTRY (nb_2_10), "");
		gtk_entry_set_text (GTK_ENTRY (nb_2_11), "");
		gtk_entry_set_text (GTK_ENTRY (nb_2_12), "");
		gtk_entry_set_text (GTK_ENTRY (nb_2_13), "");

		gtk_editable_delete_text (GTK_EDITABLE (nb_3_1), 0, -1);
		gtk_editable_delete_text (GTK_EDITABLE (nb_3_2), 0, -1);
		nb_changed = 0;
	}
	nb_isadd = 1;
	nb_setchanged (widget, NULL);
}

void
toolbar_zu (GtkWidget * widget, gpointer data)
{
	gint z;
	gchar tz[260], *a;

	if (selectleaf->nodename[0] == '\0')
		return;
	strcpy (tz, selectleaf->nodename);
	a = strchr (tz, '-');
	if (a)
		*a = '\0';
	yq_cfg_read_int (selectleaf->cfg, tz, "z", &z);
	InputName (":", "");
	if (!yesnoreturn)
		return;
	if (sFilename[0] == '\0')
	{
		Popup ("Ϊ!");
		return;
	}
	yq_cfg_write_int (selectleaf->cfg, tz, "z", z + 1);
	sprintf (tz, "%s_%d", tz, z + 1);
	yq_cfg_write_string (selectleaf->cfg, tz, "n", sFilename);
	yq_cfg_write_int (selectleaf->cfg, tz, "z", 0);
	yq_cfg_write_int (selectleaf->cfg, tz, "a", 0);
	toolbar_addzu ();
}

void
toolbar_addzu ()
{
	GtkWidget *leaf;
	gint z;
	gchar tz[260], zu[260], *zuname;
	YqTreeItem *newleaf,*zuitem;

	strcpy (tz, selectleaf->nodename);
	zuname = strchr (tz, '-');
	if (zuname)
	{
		*zuname = '\0';
		zuitem=YQ_TREE_ITEM(selectleaf->attree->tree_owner);
	}
	else
		zuitem=selectleaf;
	yq_cfg_read_int (zuitem->cfg, tz, "z", &z);
	sprintf (zu, "%s_%d", tz, z);
	yq_cfg_read_string (zuitem->cfg, zu, "n", &zuname);
	newleaf = YQ_TREE_ITEM (yq_tree_item_new (zuname, ZU_CLOSE));
	strcpy (newleaf->nodename, zu);
	g_free (zuname);
	newleaf->cfg = zuitem->cfg;
	if (!GTK_TREE_ITEM (zuitem)->subtree)
		gtk_tree_item_set_subtree (GTK_TREE_ITEM (zuitem),
				   yq_createnulltree ());
	if (!GTK_TREE_ITEM (zuitem)->expanded)
		gtk_tree_item_expand (GTK_TREE_ITEM (zuitem));
	newleaf->attree = GTK_TREE (GTK_TREE_ITEM (zuitem)->subtree);
	gtk_signal_connect (GTK_OBJECT (newleaf), "expand",
			    GTK_SIGNAL_FUNC (zu_expanded), NULL);
	gtk_signal_connect (GTK_OBJECT (newleaf), "collapse",
			    GTK_SIGNAL_FUNC (zu_collapsed), NULL);
	gtk_tree_insert (GTK_TREE
			 (GTK_TREE_ITEM (zuitem)->subtree),
			 GTK_WIDGET (newleaf), z - 1);
	gtk_tree_item_set_subtree (GTK_TREE_ITEM (newleaf),
				   yq_readzu (newleaf));
	if (yq_nowiszu)
		open_zu (zuitem);
	else
		gtk_tree_select_child (zuitem->attree,GTK_WIDGET(zuitem));
	gtk_clist_select_row (GTK_CLIST (yqlist.list), z - 1, 0);
}

void
toolbar_open (GtkWidget * widget, gpointer data)
{
	GetFilename ("YQļ");
	if (sFilename[0] != '\0')
		yq_readfile (widget, sFilename);
}

void
toolbar_rename (GtkWidget * widget, gpointer data)
{
	gchar *ab, tz[256], zu[260];
	YqTreeItem *renameitem;

	if (selectleaf->nodename[0] == '\0')
		return;

	if (!yq_nowiszu)
		return;
	if (clist_selectrow==-1)
		renameitem=selectleaf;
	else
		renameitem = (YqTreeItem *)
			gtk_clist_get_row_data (GTK_CLIST
						(yqlist.list),
						clist_selectrow);
	if (strchr(renameitem->nodename,'-')) return;
	strcpy (tz, renameitem->nodename);
	yq_cfg_read_string (renameitem->cfg, tz, "n", &ab);
	sprintf (zu, " \"%s\" Ϊ:", ab);
	InputName (zu, ab);
	if (!yesnoreturn)
		return;
	strcpy (zu, ab);
	g_free (ab);
	if (sFilename[0] == '\0')
	{
		Popup ("Ϊ!");
		return;
	}
	if (!strcmp (sFilename, zu))
	{
		Popup ("ͬ!");
		return;
	}
	yq_tree_item_set_text (renameitem, sFilename);
	yq_cfg_write_string (renameitem->cfg, tz, "n", sFilename);
	if (clist_selectrow!=-1)
			gtk_clist_set_pixtext (GTK_CLIST (yqlist.list), clist_selectrow,0, sFilename, 1, yqpixmaps[ZU_CLOSE],
					       yqmasks[ZU_CLOSE]);
}

void
toolbar_new (GtkWidget * widget, gpointer data)
{
	struct stat st;
	FILE *file;

	GetFilename ("½YQļ");
	if (sFilename[0] == '\0')
		return;
	if (!stat (sFilename, &st))
	{
		Areyousure ("ļѾ,ȷʵҪ滻?");
		if (!yesnoreturn)
			return;
	}
	create_yqfile (sFilename); /*createfile.c*/
	yq_readfile (widget, sFilename); /*treefunc.c*/
}



void
toolbar_copy (GtkWidget * widget, gpointer data)
{
/*	gchar tz[260], *a;


	if (selectleaf->nodename[0] == '\0')
		return;

	if (!tmpcfg) tmpcfg=yq_cfg_new();
	strcpy (tz, selectleaf->nodename);
	a = strchr (tz, '-');
	if (a)
		*a = '\0';
	nowincopy.iszu = yq_nowiszu;
	strcpy (nowincopy.zuname, tz);
	if (!nowincopy.iszu)
		strcpy (nowincopy.jiluname, selectleaf->nodename);
*/
}

void
toolbar_copyzu (gchar * zuname1, gchar * zuname2)
{
/*	gchar *ab, tz[260], tz2[260];
	gint i, z;

	yq_cfg_read_string (nowincopy.cfg, zuname2, "n", &ab);
	yq_cfg_write_string (selectleaf->cfg, zuname1, "n", ab);
	g_free (ab);
	yq_cfg_read_int (nowincopy.cfg, zuname2, "a", &z);
	yq_cfg_write_int (selectleaf->cfg, zuname1, "a", z);
	for (i = 1; i <= z; i++)
	{
		sprintf (tz, "%d", i);
		yq_cfg_read_string (nowincopy.cfg, zuname2, tz, &ab);
		yq_cfg_write_string (selectleaf->cfg, zuname1, tz, ab);
		g_free (ab);
	}
	yq_cfg_read_int (nowincopy.cfg, zuname2, "z", &z);
	yq_cfg_write_int (selectleaf->cfg, zuname1, "z", z);
	for (i = 1; i <= z; i++)
	{
		sprintf (tz, "%s_%d", zuname1, i);
		sprintf (tz2, "%s_%d", zuname2, i);
		toolbar_copyzu (tz, tz2);
	}
*/
}

void
toolbar_paste (GtkWidget * widget, gpointer data)
{
/*	gchar *ab, tz[256];
	gint z;

	if (nowincopy.zuname[0] == '\0')
		return;
	if (selectleaf->nodename[0] == '\0')
		return;
	if (nowincopy.iszu)
	{
		if (!yq_cfg_read_int
		    (nowincopy.cfg, nowincopy.zuname, "a", &z))
			return;
		strcpy (tz, selectleaf->nodename);
		ab = strchr (tz, '-');
		if (ab != NULL)
			*ab = '\0';
		yq_cfg_read_int (selectleaf->cfg, tz, "z", &z);
		sprintf (tz, "%s_%d", tz, z + 1);
		toolbar_copyzu (tz, nowincopy.zuname);
		yq_cfg_write_int (selectleaf->cfg, tz, "z", z + 1);
		toolbar_addzu ();
	}
	else
	{
		if (!yq_cfg_read_string
		    (nowincopy.cfg, nowincopy.zuname, nowincopy.jiluname,
		     &ab))
			return;
		toolbar_addjilu (ab);
		g_free (ab);
	}
*/
}
