#include "configfile.h"
#include <gtk/gtk.h>
#include <string.h>
#include "yqtreeitem.h"


extern GtkWidget
	* nb_1_1, *nb_1_2, *nb_1_3, *nb_1_4, *nb_1_5, *nb_1_6, *nb_1_7,
	*nb_1_8, *nb_1_9, *nb_1_10, *nb_1_11, *nb_1_12, *nb_1_13, *nb_1_14,
	*nb_1_15, *nb_1_16, *nb_1_17, *nb_1_18, *nb_2_1, *nb_2_2, *nb_2_3,
	*nb_2_4, *nb_2_5, *nb_2_6, *nb_2_7, *nb_2_8, *nb_2_9, *nb_2_10,
	*nb_2_11, *nb_2_12, *nb_2_13, *nb_3_1, *nb_3_2;

extern GtkWidget *root_leaf, *tree_main;
extern ConfigFile *rccfgfile;
extern gboolean nb_changed;

YqTreeItem *selectleaf;
gboolean yq_nowiszu;

GdkPixmap *yqpixmaps[MAX_IMAGE_TYPES];
GdkBitmap *yqmasks[MAX_IMAGE_TYPES];

GtkWidget *yq_createnulltree ();
GtkWidget *yq_readzu (YqTreeItem * upleaf);
void Popup (gchar * szMessage);
void yq_tree_item_set_pixmap (YqTreeItem * treeitem, ImageType ed);
void zu_expanded (GtkWidget * widget, gpointer data);
void zu_collapsed (GtkWidget * widget, gpointer data);
void yqfile_expanded (GtkWidget * widget, gpointer data);
void yqfile_collapsed (GtkWidget * widget, gpointer data);
void leaf_setnb (gchar * ab);
gchar *leaf_formattext (gchar * bd);
void clist_openzu (YqTreeItem * yqitem);
void open_zu (YqTreeItem * yqitem);
void yq_set_list_type (ListType type);
GtkWidget *yq_tree_item_new (gchar * ab, ImageType ed);
void yqleaf_selectionchanged (GtkWidget * tree);


void
yqleaf_selectionchanged (GtkWidget * tree)
{
	YqTreeItem *item;

	if (!GTK_TREE_SELECTION (tree))
		return;
	item = YQ_TREE_ITEM (GTK_TREE_SELECTION (tree)->data);
	selectleaf = item;
	if (item->nodename[0] == '\0')
	{
		yq_nowiszu = TRUE;
		yq_set_list_type (LIST_DETAILS);
		return;
	}
	if (strchr (item->nodename, '-'))
	{
		gchar zu[260], *ti, *ab;

		yq_nowiszu = FALSE;
		yq_set_list_type (LIST_NOTEBOOK);
		strcpy (zu, item->nodename);
		ti = strchr (zu, '-');
		*ti = '\0';
		ti++;
		yq_cfg_read_string (item->cfg, zu, ti, &ab);
		nb_changed = TRUE;
		leaf_setnb (ab);
		nb_changed = FALSE;
		g_free (ab);
	}
	else
	{
		yq_nowiszu = TRUE;
		open_zu (item);
	}
}

void
open_zu (YqTreeItem * yqitem)
{
	yq_set_list_type (LIST_DETAILS);
	clist_openzu (yqitem);
}

gchar * leaf_formattext (gchar * bd)
{
	gchar *ab, *bb;
	ab = bd;
	bb = bd;
	while (*bb != '\0')
	{
		if (*bb != '~')
		{
			if (ab != bb)
				*ab = *bb;
			ab++;
			bb++;
		}
		else
		{
			bb++;
			switch (*bb)
			{
			case '0':
				return "";
			case '~':
				*ab = '~';
				break;
			case 'n':
				*ab = '\n';
				break;
			case 'd':
				*ab = ',';
				break;
			}
			ab++;
			bb++;
		}
	}
	*ab = '\0';
	return bd;
}

void
leaf_setnb (gchar * ab)
{
	gchar *bb;
	gtk_entry_set_text (GTK_ENTRY (nb_1_1),
			    leaf_formattext (strtok (ab, ",")));

	if (*(strtok (NULL, ",")) == '1')
		gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (nb_1_2)->entry),
				    "");
	else
		gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (nb_1_2)->entry),
				    "Ů");
	if (*(strtok (NULL, ",")) == '1')
		gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (nb_1_3)->entry),
				    "");
	else
		gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (nb_1_3)->entry),
				    "");
	gtk_entry_set_text (GTK_ENTRY (nb_1_5),
			    leaf_formattext (strtok (NULL, ",")));
	if (*(strtok (NULL, ",")) == '1')
		gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (nb_1_4), 1);
	else
		gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (nb_1_4), 0);
	gtk_entry_set_text (GTK_ENTRY (nb_1_6),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_1_7),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_1_8),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_1_9),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_1_10),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_1_11),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_1_12),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_1_13),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_1_14),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_1_15),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_1_16),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_1_17),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_1_18),
			    leaf_formattext (strtok (NULL, ",")));

	gtk_entry_set_text (GTK_ENTRY (nb_2_1),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_2_2),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_2_3),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_2_4),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_2_5),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_2_6),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_2_7),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_2_8),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_2_9),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_2_10),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_2_11),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_2_12),
			    leaf_formattext (strtok (NULL, ",")));
	gtk_entry_set_text (GTK_ENTRY (nb_2_13),
			    leaf_formattext (strtok (NULL, ",")));

	gtk_text_freeze (GTK_TEXT (nb_3_1));
	gtk_editable_delete_text (GTK_EDITABLE (nb_3_1), 0, -1);
	bb = leaf_formattext (strtok (NULL, ","));
	gtk_text_insert (GTK_TEXT (nb_3_1), NULL, NULL,
			 NULL, bb, strlen (bb));
	gtk_text_thaw (GTK_TEXT (nb_3_1));
	gtk_text_freeze (GTK_TEXT (nb_3_2));
	gtk_editable_delete_text (GTK_EDITABLE (nb_3_2), 0, -1);
	bb = leaf_formattext (strtok (NULL, ","));
	gtk_text_insert (GTK_TEXT (nb_3_2), NULL, NULL,
			 NULL, bb, strlen (bb));
	gtk_text_thaw (GTK_TEXT (nb_3_2));
}

void
yqfile_expanded (GtkWidget * widget, gpointer data)
{
	yq_tree_item_set_pixmap (YQ_TREE_ITEM (widget), YQFILE_OPEN);
}

void
yqfile_collapsed (GtkWidget * widget, gpointer data)
{
	YqTreeItem *leaf;

	leaf = YQ_TREE_ITEM (widget);
	yq_tree_item_set_pixmap (leaf, YQFILE_CLOSE);
	if (selectleaf->cfg != leaf->cfg)
		return;
	if (strcmp (selectleaf->nodename, "yq") > 0)
		gtk_tree_select_child (leaf->attree, widget);
}

void
zu_expanded (GtkWidget * widget, gpointer data)
{
	yq_tree_item_set_pixmap (YQ_TREE_ITEM (widget), ZU_OPEN);
}

void
zu_collapsed (GtkWidget * widget, gpointer data)
{
	YqTreeItem *leaf;
	gint i;

	leaf = YQ_TREE_ITEM (widget);
	yq_tree_item_set_pixmap (leaf, ZU_CLOSE);

	if (selectleaf->cfg != leaf->cfg)
		return;
	if ((strcmp (selectleaf->nodename, leaf->nodename) > 0)
	    &&
	    (strncmp
	     (selectleaf->nodename, leaf->nodename,
	      strlen (leaf->nodename)) == 0))
		gtk_tree_select_child (leaf->attree, widget);
}


GtkWidget *
yq_readzu (YqTreeItem * upleaf)
{
	GtkWidget *tree;
	YqTreeItem *leaf;
	gchar *ab, *bb, ti[4], tz[260];
	gint i, z;

	tree = gtk_tree_new ();
	gtk_widget_show (tree);
	yq_cfg_read_int (upleaf->cfg, upleaf->nodename, "z", &z);	//zʾж

	for (i = 1; i <= z; i++)
	{
		sprintf (tz, "%s_%d", upleaf->nodename, i);
		yq_cfg_read_string (upleaf->cfg, tz, "n", &ab);
		leaf = YQ_TREE_ITEM (yq_tree_item_new (ab, ZU_CLOSE));
		g_free (ab);
		leaf->attree = GTK_TREE (tree);
		leaf->cfg = upleaf->cfg;
		strcpy (leaf->nodename, tz);

		gtk_signal_connect (GTK_OBJECT (leaf), "expand",
				    GTK_SIGNAL_FUNC (zu_expanded), NULL);
		gtk_signal_connect (GTK_OBJECT (leaf), "collapse",
				    GTK_SIGNAL_FUNC (zu_collapsed), NULL);

		gtk_tree_append (GTK_TREE (tree), GTK_WIDGET (leaf));
		gtk_tree_item_set_subtree (GTK_TREE_ITEM (leaf),
					   yq_readzu (leaf));
	}

	yq_cfg_read_int (upleaf->cfg, upleaf->nodename, "a", &z);	//aʾжټ¼
	for (i = 1; i <= z; i++)
	{
		sprintf (ti, "%d", i);
		sprintf (tz, "%s-%s", upleaf->nodename, ti);
		yq_cfg_read_string (upleaf->cfg, upleaf->nodename, ti, &ab);

		bb = strchr (ab, ',');
		*bb = '\0';
		if (*(bb + 1) == '1')
			leaf = YQ_TREE_ITEM (yq_tree_item_new
					     (leaf_formattext (ab), BOY));
		else
			leaf = YQ_TREE_ITEM (yq_tree_item_new
					     (leaf_formattext (ab), GIRL));

		leaf->attree = GTK_TREE (tree);
		leaf->cfg = upleaf->cfg;
		strcpy (leaf->nodename, tz);

		gtk_tree_append (GTK_TREE (tree), GTK_WIDGET (leaf));
		g_free (ab);
	}
	return tree;
}

void
yq_readfile (GtkWidget * widget, gpointer open_file)
{
	YqTreeItem *leaf;
	gchar *ab, *bb, ti[4];
	ConfigFile *cfgfile;
	gint i, a, j;

	cfgfile = yq_cfg_open_file (open_file);
	if (!cfgfile)
	{
		Popup ("ȡļʱ!");
		return;
	}

	if (!yq_cfg_read_string (cfgfile, "yq", "n", &ab))
	{
		Popup ("ⲻYQļ");
		yq_cfg_free (cfgfile);
		g_free (cfgfile);
		return;
	}
	yq_cfg_read_int (rccfgfile, "file", "a", &a);
	for (i = 1; i <= a; i++)	//ɾظļ,ÿζɨ,¼вͬ,ֻɨһ
	{
		sprintf (ti, "%d", i);
		yq_cfg_read_string (rccfgfile, "file", ti, &bb);
		if (!strcmp (bb, open_file))
		{
			g_free (bb);
			for (j = i; j < a; j++)
			{
				sprintf (ti, "%d", j + 1);
				yq_cfg_read_string (rccfgfile, "file", ti,
						    &bb);
				sprintf (ti, "%d", j);
				yq_cfg_write_string (rccfgfile, "file", ti,
						     bb);
				g_free (bb);
			}
			sprintf (ti, "%d", a);
			yq_cfg_remove_key (rccfgfile, "file", ti);
			a--;
			break;
		}
		g_free (bb);
	}
	for (i = a; i > 0; i--)	//ֻ¼5ļ
	{
		if (i != 5)
		{
			sprintf (ti, "%d", i);
			yq_cfg_read_string (rccfgfile, "file", ti, &bb);
			sprintf (ti, "%d", i + 1);
			yq_cfg_write_string (rccfgfile, "file", ti, bb);
			g_free (bb);
		}
	}
	yq_cfg_write_string (rccfgfile, "file", "1", open_file);
	if (a != 5)
		a++;
	yq_cfg_write_int (rccfgfile, "file", "a", a);


	leaf = YQ_TREE_ITEM (yq_tree_item_new (ab, YQFILE_CLOSE));
	if (!GTK_TREE_ITEM (root_leaf)->subtree)
	{
		tree_main = yq_createnulltree ();
		gtk_tree_item_set_subtree (GTK_TREE_ITEM (root_leaf),
					   tree_main);
	}
	leaf->attree = GTK_TREE (tree_main);
	leaf->cfg = cfgfile;

	strcpy (leaf->nodename, "yq");

	gtk_tree_prepend (GTK_TREE (tree_main), GTK_WIDGET (leaf));

	gtk_signal_connect (GTK_OBJECT (leaf), "expand",
			    GTK_SIGNAL_FUNC (yqfile_expanded), NULL);
	gtk_signal_connect (GTK_OBJECT (leaf), "collapse",
			    GTK_SIGNAL_FUNC (yqfile_collapsed), NULL);
	gtk_tree_item_set_subtree (GTK_TREE_ITEM (leaf), yq_readzu (leaf));

	g_free (ab);
	gtk_tree_item_expand (GTK_TREE_ITEM (leaf));
	if (!GTK_TREE_ITEM (root_leaf)->expanded)
		gtk_tree_item_expand (GTK_TREE_ITEM (root_leaf));
	gtk_tree_select_item (GTK_TREE (tree_main), 0);
	cfgfile = NULL;
}
